Arch BuildingPart

From FreeCAD Documentation
Revision as of 14:51, 18 October 2021 by Roy 043 (talk | contribs)
Jump to navigation Jump to search
Other languages:
Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎română • ‎русский
Arrow-left.svg Previous: Arch Floor.svg Floor
Next: Building Arch Building.svg Arrow-right.svg

Arch BuildingPart.svg Arch BuildingPart

Menu location
Arch → BuildingPart
Workbenches
Arch
Default shortcut
None
Introduced in version
0.18
See also
Arch Building, Arch Site

Description

The BuildingPart replaces the old Arch Floor and Arch Building with a more capable version that can be used not only to create Floor/Storey/Levels but also all kinds of situations where different Arch/BIM objects need to be grouped and that group might need to be handled as one object or replicated.

Usage

  1. Optionally, select one or more objects to be included in your new Building Part.
  2. Press the Arch BuildingPart.svg Arch BuildingPart button.

Notes

BuildingParts have a built-in, implicit Arch SectionPlane. introduced in version 0.19

This plane is always parallel to the BuildingPart's base plane, but you can specify the offset between them. So all tools that work with a section plane, such as Draft Shape2DView and TechDraw ArchView also work with BuildingParts.

Options

  • After creating a BuildingPart, you can add more objects to it by dragging and dropping them in the Tree View or by using the Arch Add.svg Arch Add tool.
  • You can remove objects from a BuildingPart by dragging and dropping them out of the Tree View or by using the Arch Remove.svg Arch Remove tool.
  • By double-clicking the BuildingPart object in the tree view, the Working Plane will be set to its location, and the BuildingPart will become active, which means that new objects will be added automatically to it. Double-clicking the BuildingPart again will deactivate it and set the working plane back to its previous position (in version 0.19, to be available this option needs to be set up as true, in View Property panel - Interaction - Double Click Activates).
  • The BuildingPart can display a mark in the 3D view with a label and level indication.
  • When a BuildingPart is moved/rotated, all its children that either have no DataMove With Host property, or have it turned on, will move/rotate together.
  • Building Parts can be Draft Cloned.
  • Building Parts can take any IFC type. Its IFC Type property determines its use. If you set it to Building Storey it will behave as a level. If you set it to Building it behaves as a building, and if you set it to Element Assembly it behaves as an assembly. Its icon will change to reflect this setting, but other than that it has no other impact in FreeCAD. However, being exported to IFC as one or another type can have an impact in other BIM applications.
  • Building Parts allow to define an Auto-group capture box. Subsequent Draft and Arch objects, or anything else that uses Draft.autogroup(), will be automatically added to that Building Part if they are fully inside the capture box. introduced in version 0.20

Properties

See also: Property editor.

An Arch BuildingPart is derived from an App GeoFeature object and inherits all its properties. It also has the following additional properties:

Data

Base

  • DataGroup (LinkList): List of referenced objects.
  • Data (Hidden)_ Group Touched (Bool)

Building Part

  • DataArea (Area): The computed floor area of this floor.
  • DataHeight (Length): The height of this object, and of its children objects. The children objects could be, for example, Arch Walls. Each wall's height must be set to 0 (zero), so the height property of the BuildingPart propagates to the objects inside of it.
  • DataLevel Offset (Length): The level of the (0,0,0) point of this level. This value is added to the Placement.Base.z attribute of the BuildingPart, to indicate a vertical offset without actually moving the object. The resulting offset is displayed if ViewShow Level is true.
  • Data (Hidden)Materials Table (Map): A MaterialName:SolidIndexesList map that relates material names with solid indexes to be used when referencing this object from other files.
  • DataOnly Solids (Bool): If true, only solids will be collected by this object when referenced from other files.
  • Data (Hidden)Saved Inventor (FileIncluded): This property stores an inventor representation for this object.
  • Data (Hidden)Shape (PartShape): The shape of this object.

Children

  • DataHeight Propagate (Bool): If true, the height value propagates to contained objects.

IFC

  • Data (Hidden)Ifc Data (Map): IFC data.
  • Data (Hidden)Ifc Properties (Map): IFC properties of this object.
  • DataIfc Type (Enumeration): The IFC type of this object.

IFC Attributes

  • DataDescription (String): An optional description for this component
  • DataGlobal Id (String)
  • DataObject Type (String)
  • DataOverall Height (Length)
  • DataOverall Width (Length)
  • DataPartitioning Type (Enumeration)
  • DataPredefined Type (Enumeration)
  • DataTag (String): An optional tag for this component.
  • DataUser Defined Partitioning Type (String)

View

Auto Group

  • ViewAutogroup Size (IntegerList): The capture box for newly created objects expressed as [XMin,YMin,ZMin,XMax,YMax,ZMax]. introduced in version 0.20

Building Part

  • ViewDiffuse Color (ColorList): The individual face colors.
  • ViewDisplay Offset (Placement): A transformation to apply to the level mark.
  • ViewFont Name (Font): The font to be used for texts.
  • ViewFont Size (Length): The font size of texts.
  • ViewLine Width (Float): The line width of this object.
  • ViewOrigin Offset (Bool): If true, when activated, Display offset will affect the origin mark too.
  • ViewOverride Unit (String): An optional unit to express levels.
  • ViewShow Label (Bool): If true, when activated, the object's label is displayed.
  • ViewShow Level (Bool): If true, show the level.
  • ViewShow Unit (Bool): If true, show the unit on the level tag.

Children

  • ViewChildren Line Color (Color): The line color to apply to the children of this Building Part.
  • ViewChildren Line Width (Float): The line width to apply to the children of this Building Part.
  • ViewChildren Override (Bool): If true, the objects contained in this Building Part will adopt these line, color and transparency settings.
  • ViewChildren Shape Color (Color): The shape color to apply to the children of this Building Part.
  • ViewChildren Transparency (Percent): The transparency to apply to the children of this Building Part.

Clip

  • ViewAuto Cut View (Bool): Turn cutting on when activating this level.
  • ViewCut Margin (Length): The distance between the level plane and the cut line.
  • ViewCut View (Bool): Cut the view above this level.

Interactions

  • ViewAuto Working Plane (Bool): If set to True, the working plane will be kept on Auto mode.
  • ViewDouble Click Activates (Bool): If True, double-clicking this object in the tree activates it.
  • ViewRestore View (Bool): If set, the view stored in this object will be restored on double-click.
  • ViewSave Inventor (Bool): If this is enabled, the inventor representation of this object will be saved in the FreeCAD file, allowing to reference it in other files in lightweight mode.
  • ViewSaved Inventor (FileIncluded): A slot to save the inventor representation of this object, if enabled.
  • ViewSet Working Plane (Bool): If true, when activated, the working plane will automatically adapt to this Building Part.
  • ViewView Data (FloatList): Camera position data associated with this object.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The BuildingPart tool can be used in macros and from the Python console by using the following function:

BuildingPart = makeBuildingPart(objectslist=None)
  • Creates a BuildingPart object from objectslist, which is a list of objects.

Example:

import FreeCAD, Draft, Arch

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
baseline = Draft.makeLine(p1, p2)
baseline2 = Draft.makeLine(p1, -1*p2)

Wall1 = Arch.makeWall(baseline, length=None, width=150, height=2000)
Wall2 = Arch.makeWall(baseline2, length=None, width=150, height=1800)
FreeCAD.ActiveDocument.recompute()

BuildingPart = Arch.makeBuildingPart([Wall1, Wall2])

Floor = Arch.makeFloor([BuildingPart])
Building = Arch.makeBuilding([Floor])
Site = Arch.makeSite(Building)
FreeCAD.ActiveDocument.recompute()


Arrow-left.svg Previous: Arch Floor.svg Floor
Next: Building Arch Building.svg Arrow-right.svg